function [data, vidnum]=test2()
%Takes video, outputs video structure containing separate video, as well as
%a variable containing the number of videos. Enter numframes=1 to take 1
%picture
clc


%What devices are available
%imaqhwinfo
%What properties does the 1394 camera have (assumes it is present)
%imaqhwinfo('dcam',1)

%Create a video device using 1394 camera

numframes = 300; %adjust number of frames to take
fps=30;
if ~exist('vid')
    'create videoinput object'
    tic
    vid = videoinput('dcam');
    toc 
end

'set properties'
tic
config=triggerinfo(vid)
triggerconfig(vid,config(3)); %sets trigger configuration to  'hardware','fallinedge','externaltrigger'
set(vid,'FramesPerTrigger',1)
set(vid,'TriggerRepeat',numframes-1)
set(vid,'ROIPosition',[0 0 1024 768/4])
set(vid,'Timeout',5000)
toc

%start acquisition (on my system default is to take 10 frames)
'start video'

start(vid)
islogging(vid)
while islogging(vid)==1
end
'logging'
    %get the frames and times from the video buffer associated with vid
    'get data'
    tic
    [frames times] = getdata(vid,numframes);
    framestart=1;
    vidnum=0;
    for i=1:numframes-1
        d=times(i+1)-times(i);
        if d>(2/fps)
            vidnum=vidnum+1;
            data.frames(vidnum).frames=frames(:,:,framestart+1:i);
            framestart
            i
            framestart=i;
            
        elseif (i==numframes-1)&(vidnum==0)
            vidum=vidnum+1
            data.frames(vidnum).frames=frames(:,:,framestart+1:i);
        end
    end
        
    toc
    'done'
    %clear the video objects
    %'clean up'
    %delete(vid)
    %clear vid
    flushdata(vid)
%plotting images
figure(2)
clf
axis off
colormap('gray')
for i = 1:numframes
    imagesc(frames(:,:,i));
    ylim = get(gca,'ylim');
    axis equal
    set(gca,'ylim',ylim)
    title(['Frame: ',num2str(i)])
    pause(.01)
end

