function [M]=calim(im)
%takes as input calibration image and outputs perspective transformation
%matrix using perspective function. Spacing of calibration dots can be
%edited below
    thresh = graythresh(im);
    bw = (im >= thresh * 170);
    bw=~bw;
    imshow(bw)
   
   rect=imrect
   pos=getPosition(rect);
   cropped=bw(pos(2):pos(2)+pos(4),pos(1):pos(1)+pos(3));
   imshow(cropped)
   L=bwlabel(cropped);
    s  = regionprops(L, 'centroid');
   centroids = cat(1, s.Centroid);
   centroids(:,1)=centroids(:,1)+pos(1)-1;
   centroids(:,2)=centroids(:,2)+pos(2)-1;
   %imshow(bw)
   %hold on
   %plot(centroids(:,1), centroids(:,2), 'b.')
   %hold off
   %figure
    Y=sortrows(centroids);
    [a b]= size(centroids);
    for i=1:a/5
        X=sortrows(Y((i*5-4:i*5),:),-2);
        Y(i*5-4:i*5,:)=X;
    end
   Y;
   Y(:,2)=Y(:,2);
   %create real coordinate matrix using specified dot spacing
    Xnum=11;
    Ynum=5;
    Xspace=6;
    Yspace=3;
    count=1;
    RC=zeros(Xnum*Ynum,2);
    for i=1:Xnum
        for j=1:Ynum
            RC(count,:)=[(i-1)*Xspace,(j-1)*Yspace];
            count=count+1;
        end
    end
    RC(:,1)=RC(:,1)-(Xnum-1)/2*Xspace;
    RC(:,2)=RC(:,2)-(Ynum-1)/2*Yspace;
    RC=RC';
    Y=Y';
    M=perspective(Y,RC);
    figure
    RC(3,:)=ones(1,55)
    RCpixels=M^(-1)*RC
    RCpixels=RCpixels./RCpixels(3,1)
    imshow(bw)
    hold on
    plot(RCpixels(1,:), RCpixels(2,:), 'b.')
