function [x,y]=calvid(data,image)
%takes as input the calibration video and calibration image. Outputs the x
%and y motion data. 
imshow(data(:,:,:,end))
fps=30;
box=100;
[w x] =ginput(1);
numframes=size(data(1,1,1,:));
numframes=numframes(4);

g=data;
thresh = graythresh(g);
bw = (g >= thresh * 170);
bw=~bw;

for k=numframes-1:-1:1
    if k==numframes-1
        cropped(:,:,k)=imcrop(bw(:,:,k),[w-box/2 x-box/2 box box]);
        cropped(:,:,k) = bwareaopen(cropped(:,:,k), 5, 8);
        s  = regionprops(cropped(:,:,k), 'centroid');
        centroids(:,k)= s.Centroid;

        centroids(1,k)=centroids(1,k)+w-box/2; %convert centroid location from cropped box to location in full image
        centroids(2,k)=centroids(2,k)+x-box/2;
    else

        cropped(:,:,k)=imcrop(bw(:,:,k),[centroids(1,k+1)-box/2 centroids(2,k+1)-box/2 box box]);
        cropped(:,:,k) = bwareaopen(cropped(:,:,k), 5, 8);
        %count=count+1
        CC = bwconncomp(cropped(:,:,k));
        numobjects=CC.NumObjects;
        if numobjects==1
                s  = regionprops(cropped(:,:,k), 'centroid');
                centroids(:,k)= s.Centroid;
                %figure
                %imshow(cropped(:,:,k))
                centroids(1,k)=centroids(1,k)+(centroids(1,k+1)-box/2); %convert centroid location from cropped box to location in full image
                centroids(2,k)=centroids(2,k)+(centroids(2,k+1)-box/2);
        else

            if abs(centroids(2,k+1)-x)>30
                count=count+1
                figure
                count=count+1
                imshow(cropped(:,:,k))
                extents=regionprops(cropped(:,:,k),'extrema')
                ex=extents.Extrema
                centroids(1,k)=ex(6,1)+(centroids(1,k+1)-box/2);
                centroids(2,k)=ex(6,2)+(centroids(2,k+1)-box/2);
            else


            end 

        end
    end
end
figure
imshow(data(:,:,:,1))
hold on
plot(centroids(1,:),centroids(2,:),'b*')
figure
centroids(3,:)=ones(1,numframes-1)
M=calim(image);
for k=numframes-1:-1:1
    r=M*centroids(:,k);
    centroids(:,k)=r./r(3); %convert camera coordinates to world coordinates
end
time=0:1/fps:numframes/fps-2/fps;
figure
plot(time,centroids(1,:));xlabel('time');ylabel('x position (mm)')%ylim([-10 10])
figure
plot(time,centroids(2,:));xlabel('time');ylabel('y position (mm)')%ylim([-25 25])
x=centroids(1,:);
y=centroids(2,:);
