
function [X] = perspective(q_C_all, r_W_all)
%takes as inputs world coordinates of calibration image dots (r_w_all) and
%camera coordinates of calibration image dots (q_C_all), and outputs the
%perspective transformation matrix X
[v c]=size(r_W_all);
[g h]=size(q_C_all);
A=zeros(2*c,6);
B=zeros(2*c,1);
for j=1:2*c
    if mod(j,2)==1
        A(j,1)=q_C_all(1,ceil(j/2));
    end
end
for j=1:2*c
    if mod(j,2)==1
        A(j,2)=q_C_all(2,ceil(j/2));
    end
end
for j=1:2*c
    if mod(j,2)==1
        A(j,3)=1;
    end
end
for j=1:2*c
    if mod(j,2)==0
        A(j,4)=q_C_all(1,ceil(j/2));
    end
end
for j=1:2*c
    if mod(j,2)==0
        A(j,5)=q_C_all(2,ceil(j/2));
    end
end
for j=1:2*c
    if mod(j,2)==0
        A(j,6)=1;
    end
end
for j=1:2*c
    if mod(j,2)==1
        A(j,7)=-q_C_all(1,ceil(j/2))*r_W_all(1,ceil(j/2));
    else
        A(j,7)=-q_C_all(1,ceil(j/2))*r_W_all(2,ceil(j/2));
    end
end
for j=1:2*c
    if mod(j,2)==1
        A(j,8)=-q_C_all(2,ceil(j/2))*r_W_all(1,ceil(j/2));
    else
        A(j,8)=-q_C_all(2,ceil(j/2))*r_W_all(2,ceil(j/2));
    end
end

for j=1:2*c
    if mod(j,2)==1
        B(j)=r_W_all(1,ceil(j/2));
    else
        B(j)=r_W_all(2,ceil(j/2));
    end
end
X=A\B;
X=[X(1),X(2),X(3);X(4),X(5),X(6);X(7),X(8),1]



