function []=plotcentroids(result)
%Takes a struct as input (the output from the trackmovemaster program),
%displays summary statistics for the videos, and graphs and saves relevant
%parameters in the current directory
numvids=numel(result)
title1='Trans Field. Z Phase = 10/8*pi'%[num2str(result(1).ay) ' m/s^2 at ' num2str(result(1).fps) ' Hz'];
for i=numvids:-1:1
    numframes=numel(result(i).centroids(1,:));
    xpos(1:numframes,i)=result(i).centroids(1,:)';
    time1(1:numframes,i)=result(i).time';
    xpos(xpos==0)=nan;
    time1(time1==0)=nan;
end
for i=numvids:-1:1
    numframes=numel(result(i).centroids(1,:));
    ypos(1:numframes,i)=result(i).centroids(2,:)';
    time2(1:numframes,i)=result(i).time';
    ypos(ypos==0)=nan;
    time2(time2==0)=nan;
end

for i=numvids:-1:1
    numframes=numel(result(i).velocity);
    xvel(1:numframes,i)=result(i).velocity';
    time3(1:numframes,i)=result(i).time(1:end-1)';
    xvel(xvel==0)=nan;
    time3(time3==0)=nan;
end

for i=numvids:-1:1
    numframes=numel(result(i).orientation);
    orientation(1:numframes,i)=result(i).orientation';
    time4(1:numframes,i)=result(i).time';
    orientation(orientation==0)=nan;
    time4(time4==0)=nan;
end
for i=numvids:-1:1
    xvelmean(i)=result(i).xvelmean;
    xvelstd(i)=result(i).xvelstd;
    yvelmean(i)=result(i).yvelmean;
    yvelstd(i)=result(i).yvelstd;
    orientationmean(i)=result(i).orientationmean;
end
for i=numvids:-1:1
    numframes=numel(result(i).yvelocity);
    yvel(1:numframes,i)=result(i).yvelocity';
    time5(1:numframes,i)=result(i).time(1:numframes)';
    yvel(yvel==0)=nan;
    time5(time5==0)=nan;
end
velocityangle=atand(abs(yvelmean)./abs(xvelmean));
velocityanglemean=mean(velocityangle)
velocityanglestd=std(velocityangle)
xvelmean=mean(xvelmean)
xvelstd=mean(xvelstd)
yvelmean=mean(yvelmean)
yvelstd=mean(yvelstd)
orientationmean=mean(orientationmean)
velocitymag=(yvelmean^2+xvelmean^2)^(1/2)
velocitymagstd=(yvelstd^2+xvelstd^2)^(1/2)

plot(time1,xpos);xlabel('time (s)');ylabel('x position (mm)');title(title1)
saveas(gcf,'x pos vs time')
figure
plot(time2,ypos);xlabel('time (s)');ylabel('y position (mm)');title(title1)
saveas(gcf,'y pos vs time')
figure
plot(time3,xvel);xlabel('time (s)');ylabel('x velocity (mm/s)');title(title1)
saveas(gcf,'x vel vs time')
figure

plot(time5,yvel);xlabel('time (s)');ylabel('y velocity (mm/s)');title(title1)
saveas(gcf,'y vel vs time')
figure

plot(time4,orientation);xlabel('time (s)');ylabel('orientation (deg)');title(title1)
saveas(gcf,'orientation vs time')
figure
plot(xpos(1:end-1,:),xvel);xlabel('x position (mm)');ylabel('x velocity (mm/s)');title(title1)
saveas(gcf,'x vel vs x pos')
figure

plot(ypos(1:end-1,:),yvel);xlabel('y position (mm)');ylabel('y velocity (mm/s)');title(title1)
saveas(gcf,'y vel vs y pos')
figure

plot(orientation(1:end-1,:),xvel,'.');xlabel('orientation (deg)');ylabel('x velocity (mm/s)');title(title1)
saveas(gcf,'x vel vs orientation')
