function[allcentroids]=trackmovemasterside(data)
%Sse when it is appropriate to trim the data using y position values, in
%stead of x position values. Takes a struc as input, the output of the
%GetFrames program, with added information about the PPOD plate motion. To
%use, call function, drag rectangle around region of image only containing
%calibration dots, then click the micropart for each video when it is
%displayed.
X=calim(data.calibrationimage); %Determine transformation matrix
xmax=X^(-1)*[-10;0;1];xmax=xmax(1);
xmin=X^(-1)*[-22;0;1];xmin=xmin(1);
ymax=X^(-1)*[0;3;1];ymax=ymax(2) %enter ymax trimming value
ymin=X^(-1)*[0;-3;1];ymin=ymin(2) %enter ymin trimming value
ytest=X^(-1)*[0;0;1];ytest=ytest(2)
s=data.frames(1).frames;
fps=data.fps;
box=55; %size of cropped box
[a b]=size(data.frames);
count=0;
limcheck=0;
vidnumber=1;


for g=[1,2,3,4,5,6]%:numel(data.frames) %cycle through videos in struct
    xmincheck=0;
    ymincheck=0;
    clear centroids
    clear a
    clear xvel
    clear xvelnofilter
    clear yvel
    clear time
    s=data.frames(g).frames;
    numframes=size(s(1,1,:));
    numframes=numframes(3);
    for i = numframes:-1:2
    s(:, :, i) = imabsdiff(s(:, :, i), data.frames(g).frames(:,:,2)); %difference video
    end
    thresh=graythresh(s); %grey threshold video
     bw=(s >= thresh*140); 
    for k=numframes-1:-1:1 %cycle backwards through frames of video. throw out frames of video which do not show the part
                check(:,:,k)=bw(40:ytest,:,k); 
                check(:,:,k) = bwareaopen(check(:,:,k), 7, 8);
                 se=strel('disk',12);
                check(:,:,k)=imclose(check(:,:,k),se);
                L=bwlabel(check(:,:,k));
                s  = regionprops(L, 'centroid');
                [L numobjects]=bwlabel(check(:,:,k));
               if numobjects~=0
                   [aa]=s.Centroid;
                   
                   bw=bw(:,:,1:k-2);
                   break
               end                    
    end
    size(bw)
    imshow(bw(:,:,end))
    [w x]=ginput(1); %click on part
    numframes=size(bw(1,1,:));
    numframes=numframes(3);
    for k=numframes-1:-1:1
            if k==numframes-1
                cropped(:,:,k)=imcrop(bw(:,:,k),[w-box/2 x-box/2 box box]); %crop image to size of box, centered around user's click
                cropped(:,:,k) = bwareaopen(cropped(:,:,k), 5, 8);%get rid of white blobs fewer than 5 pixels
                 se=strel('disk',12);
                cropped(:,:,k)=imclose(cropped(:,:,k),se);%fill in black parts of part blob
                L=bwlabel(cropped(:,:,k));
                s  = regionprops(L, 'centroid');
                [aa]=s.Centroid; %determine centroid
                a(k)=secondmoment(L,aa);%determine orientation
                centroids(:,k)= aa;
                centroids(1,k)=centroids(1,k)+w-box/2; %convert centroid location from cropped box to location in full image
                centroids(2,k)=centroids(2,k)+x-box/2;
                limcheck=(aa(1)+w-box/2);
            else
                cropped(:,:,k)=imcrop(bw(:,:,k),[centroids(1,k+1)-box/2 centroids(2,k+1)-box/2 box box]);
                cropped(:,:,k) = bwareaopen(cropped(:,:,k), 5, 8);
                se=strel('disk',12);
                cropped(:,:,k)=imclose(cropped(:,:,k),se);
                [L numobjects]=bwlabel(cropped(:,:,k));
                s=regionprops(L,'centroid');
               a(k)=secondmoment(L,aa);
                if numobjects==0
                    centroids(:,k)=centroids(:,k+1);
                elseif numobjects==1
                    s  = regionprops(L, 'centroid');
                    [aa]=s.Centroid;
                    centroids(:,k)=aa;
                    centroids(1,k)=centroids(1,k)+(centroids(1,k+1)-box/2); %convert centroid location from cropped box to location in full image
                    centroids(2,k)=centroids(2,k)+(centroids(2,k+1)-box/2);
                else
                    s  = regionprops(L, 'centroid');
                    [aa bb]=s.Centroid;
                    centroids(:,k)= [(aa(1)+bb(1))/2 (aa(2)+bb(2))/2]; %if two white blobs show up, average them
                    centroids(1,k)=centroids(1,k)+(centroids(1,k+1)-box/2); %convert centroid location from cropped box to location in full image
                    centroids(2,k)=centroids(2,k)+(centroids(2,k+1)-box/2);
                end
                    limcheck=(aa(2)+(centroids(2,k+1)-box/2)); 
                    if limcheck<ymax & ymincheck==0%For forward motion. determine where to trim data
                        'frameend reached'
                        frameend=k;
                        ymincheck=ymincheck+1;
                    end
                    if limcheck>ymin
                        framestart=k+1;
                        break
                    end
       
                     %{
                    if limcheck<xmax & xmincheck==0 %For backwards motion
                        frameend=k+1;
                        xmincheck=xmincheck+1;
                    end
                   
                    if limcheck<xmin 
                        framestart=k+1;
                        break
                    end
                    
                        %}
            end
        %{
            figure %plot centroids and orientations
            imshow(data.frames(g).frames(:,:,k))
            hold on 
            xorient=[centroids(1,k)+30*cosd(-a(k)),centroids(1,k)-30*cosd(-a(k))];
            yorient=[centroids(2,k)+30*sind(-a(k)),centroids(2,k)-30*sind(-a(k))];
            plot(xorient,yorient)
            plot(centroids(1,k),centroids(2,k),'b*')
            %}
    end
 if ymincheck==0
 'frameend not reached'
 frameend=numel(bw(1,1,:))-1;
 end

numframes=frameend-framestart;
centroids=centroids(:,framestart:(frameend-1));
%%{
imshow(data.frames(g).frames(:,:,1)) %plot centroids
hold on
plot(centroids(1,:),centroids(2,:),'b.')
%%}
centroids(3,:)=ones(1,numframes)
for k=numframes:-1:1
    r=X*centroids(:,k);
    centroids(:,k)=r./r(3); %convert camera coordinates to world coordinates
end
time=0:1/fps:numframes/fps-1/fps;
dt=1/fps;
for k=numframes-1:-1:1
    xvelnofilter(k)=(centroids(1,k+1)-centroids(1,k))/(1/fps);
    yvel(k)=(centroids(2,k+1)-centroids(2,k))/(1/fps);
end

for k=framestart:frameend
        a(k)=a(k);
end
a=a(framestart:frameend-1);
allcentroids(vidnumber).centroids=centroids;
allcentroids(vidnumber).time=time;
allcentroids(vidnumber).orientation=a;
allcentroids(vidnumber).velocity=xvelnofilter;
allcentroids(vidnumber).yvelocity=yvel;
allcentroids(vidnumber).xvelmean=mean(xvelnofilter);
allcentroids(vidnumber).yvelmean=mean(yvel);
allcentroids(vidnumber).orientationmean=mean(a);
allcentroids(vidnumber).xvelstd=std(xvelnofilter);
allcentroids(vidnumber).yvelstd=std(yvel);
allcentroids(vidnumber).fps=fps;
allcentroids(vidnumber).ay=data.platemotion.ay;
allcentroids(vidnumber).ax=data.platemotion.ax;
vidnumber=vidnumber+1;
end













